import java.sql.*;
/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */

public class DatabaseManipulator {
  // ORACLE JDBC Driver
  String driverName    = "oracle.jdbc.driver.OracleDriver";

  // Connection to specific ORACLE database
  String connectionURL = "jdbc:oracle:oci8:SYSTEM/csrocks55@oracle";
  Driver driver;
  Connection connection;

  public void setDriverName(String value)
  {
    driverName = value;
  }

  public String getDriverName()
  {
    return driverName;
  }

  public void setConnectionURL(String value)
  {
    connectionURL = value;
  }

  public String getConnectionURL()
  {
    return connectionURL;
  }

 /////////////////////////////////////////////////////////////
 // CONNECT TO DATABASE
 /////////////////////////////////////////////////////////////
 private void connectToDatabase()
 {
   try {
     System.out.println("Trying to connect to database...");

     // Load the database specific vendor driver
     driver = (java.sql.Driver) Class.forName(driverName).newInstance();

     // Connect to the database
     connection = DriverManager.getConnection(connectionURL);

     System.out.println("Connection successful!");
   }
   catch (Exception e) {
     e.printStackTrace();
   }
 }


  /////////////////////////////////////////////////////////////
  // DISCONNECT FROM DATABASE.
  /////////////////////////////////////////////////////////////
  public void disconnectFromDatabase()
  {
    try {
      System.out.println("Trying to disconnect from database...");
      connection.close();
      System.out.println("Disconnection successful!");
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }


  /////////////////////////////////////////////////////////////
  // SELECT EXAMPLE
  /////////////////////////////////////////////////////////////
  public void selectExample()
  {
    try
    {
      // statement will hold the query
      Statement statement = connection.createStatement();

      // Execute query, result set will hold the tuples that return
      ResultSet resultSet = statement.executeQuery("SELECT * FROM ACCOUNT");

      // Iterate through result set, printing out account tuples
      double total = 0.0;
      while (resultSet.next()) {
        System.out.print(resultSet.getString("name") + "\t\t");
        System.out.print(resultSet.getString("address") + "\t");
        System.out.print(resultSet.getString("id") + "\t");
        System.out.println(resultSet.getString("amount"));

        // wasNull() returns true if the attribute returned from
        // the last column was actually NULL.  We need to know if
        // amount was null so we don't add something silly to the
        // running total.
        if (!resultSet.wasNull()) {
          total = total + resultSet.getDouble("amount");
        }
      }

      System.out.println("Total in all accounts is: " + Double.toString(total));

      // Cleanup
      resultSet.close();
      statement.close();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

 /////////////////////////////////////////////////////////////
 // INSERT EXAMPLE
 /////////////////////////////////////////////////////////////
 public void insertExample()
 {
    System.out.println(">>>INSERTING RECORD<<<");
   try
   {
     Statement statement = connection.createStatement();
     statement.executeUpdate("INSERT INTO ACCOUNT VALUES ('Becky Dugan', 'Wayland, MA 01778', 32, 100000)");
     statement.close();
   }
   catch (Exception e) {
     e.printStackTrace();
   }
 }

 /////////////////////////////////////////////////////////////
 // UPDATE EXAMPLE
 /////////////////////////////////////////////////////////////
 public void updateExample()
 {
    System.out.println(">>>UPDATING RECORD<<<");
   try
   {
     Statement statement = connection.createStatement();
     statement.executeUpdate("UPDATE ACCOUNT SET AMOUNT=AMOUNT*1.1 WHERE ID = 42");
     statement.close();
   }
   catch (Exception e) {
     e.printStackTrace();
   }
 }

/////////////////////////////////////////////////////////////
// DELETE EXAMPLE
/////////////////////////////////////////////////////////////
 public void deleteExample()
 {
   System.out.println(">>>DELETING RECORD<<<");
   try
   {
     Statement statement = connection.createStatement();
     statement.executeUpdate("DELETE FROM ACCOUNT WHERE ID = 32");
     statement.close();
   }
   catch (Exception e) {
     e.printStackTrace();
   }
 }

// Finalize method disconnects on garbage collection
public void finalize()
 {
     disconnectFromDatabase();
 }

 // Constructor connects to db
 DatabaseManipulator()
 {
   connectToDatabase();
 }

}
